#ifndef APPLICATION_H
#define APPLICATION__H
#include "wx/wx.h"
//#include "cv.h"
#include "Munkres.h"
#include "Image.h"
#include "TPS.h"
#include "CaptchaWindow.h"
#include "MainWindow.h"
#include <boost/numeric/ublas/vector.hpp>
using namespace boost::numeric::ublas;



class Application: public wxApp {
    public:
        Application();
        virtual bool OnInit();
        Image* getImage();
        Image* getImage2();
        void run();
        void setImage1(Image* img);
        void setImage2(Image* img);
        long double getBendingEnergy();
        double getOptimalCost();
        TPS getTPS();
        void setImages(std::vector<Image*> imgs);
        std::vector<Image*> getImages();
    private:
        MainWindow *mainWindow;
        CaptchaWindow *captchaWindow;
        Munkres munkresSolver;
        TPS tps;
        Image *img1;
        Image *img2;
        double optimalCost;
        long double bendingEnergy;
        std::vector<Image*> imgs;
};

#endif
