#include "CaptchaMain.h"
#include "CaptchaWindow.h"
#include <wx/msgdlg.h>

//(*InternalHeaders(CaptchaFrame)
#include <wx/string.h>
#include <wx/intl.h>
#include <wx/font.h>
#include <wx/bitmap.h>
#include <wx/image.h>
#include <wx/artprov.h>
//*)

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

//(*IdInit(CaptchaFrame)
const long CaptchaFrame::ID_CHOICE2 = wxNewId();
const long CaptchaFrame::ID_STATICBITMAP1 = wxNewId();
const long CaptchaFrame::ID_STATICBITMAP3 = wxNewId();
const long CaptchaFrame::ID_LISTBOX3 = wxNewId();
const long CaptchaFrame::ID_STATICTEXT1 = wxNewId();
const long CaptchaFrame::ID_LISTBOX4 = wxNewId();
const long CaptchaFrame::ID_LISTBOX5 = wxNewId();
const long CaptchaFrame::ID_PANEL1 = wxNewId();
const long CaptchaFrame::ID_CHOICE3 = wxNewId();
const long CaptchaFrame::ID_STATICBITMAP6 = wxNewId();
const long CaptchaFrame::ID_PANEL3 = wxNewId();
const long CaptchaFrame::ID_NOTEBOOK1 = wxNewId();
const long CaptchaFrame::ID_TOOLBARITEM3 = wxNewId();
const long CaptchaFrame::ID_TOOLBARITEM2 = wxNewId();
const long CaptchaFrame::ID_TOOLBARITEM4 = wxNewId();
const long CaptchaFrame::ID_TOOLBARITEM1 = wxNewId();
const long CaptchaFrame::ID_TOOLBAR1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(CaptchaFrame,wxFrame)
    //(*EventTable(CaptchaFrame)
    //*)
END_EVENT_TABLE()

CaptchaFrame::CaptchaFrame(wxWindow* parent,wxWindowID id)
{
    //(*Initialize(CaptchaFrame)
    wxBoxSizer* BoxSizer4;
    wxBoxSizer* BoxSizer1;
    wxBoxSizer* BoxSizer6;
    wxBoxSizer* BoxSizer5;

    Create(parent, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("wxID_ANY"));
    SetClientSize(wxSize(543,520));
    Notebook1 = new wxNotebook(this, ID_NOTEBOOK1, wxPoint(264,224), wxSize(543,480), 0, _T("ID_NOTEBOOK1"));
    Panel1 = new wxPanel(Notebook1, ID_PANEL1, wxPoint(94,184), wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL1"));
    BoxSizer1 = new wxBoxSizer(wxHORIZONTAL);
    BoxSizer5 = new wxBoxSizer(wxVERTICAL);
    letterChoice = new wxChoice(Panel1, ID_CHOICE2, wxDefaultPosition, wxDefaultSize, 0, 0, 0, wxDefaultValidator, _T("ID_CHOICE2"));
    BoxSizer5->Add(letterChoice, 0, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    bmpCaptcha = new wxStaticBitmap(Panel1, ID_STATICBITMAP1, wxNullBitmap, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICBITMAP1"));
    BoxSizer5->Add(bmpCaptcha, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    bmpCountour = new wxStaticBitmap(Panel1, ID_STATICBITMAP3, wxNullBitmap, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICBITMAP3"));
    BoxSizer5->Add(bmpCountour, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    lettersList = new wxListBox(Panel1, ID_LISTBOX3, wxDefaultPosition, wxSize(343,160), 0, 0, 0, wxDefaultValidator, _T("ID_LISTBOX3"));
    lettersList->SetBackgroundColour(wxColour(239,239,208));
    BoxSizer5->Add(lettersList, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    BoxSizer1->Add(BoxSizer5, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    BoxSizer6 = new wxBoxSizer(wxVERTICAL);
    StaticText1 = new wxStaticText(Panel1, ID_STATICTEXT1, _("Palavras possíveis:         "), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
    BoxSizer6->Add(StaticText1, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    wordsList = new wxListBox(Panel1, ID_LISTBOX4, wxDefaultPosition, wxDefaultSize, 0, 0, wxLB_SORT|wxSIMPLE_BORDER, wxDefaultValidator, _T("ID_LISTBOX4"));
    BoxSizer6->Add(wordsList, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    rankList = new wxListBox(Panel1, ID_LISTBOX5, wxDefaultPosition, wxDefaultSize, 0, 0, 0, wxDefaultValidator, _T("ID_LISTBOX5"));
    wxFont rankListFont(12,wxSWISS,wxFONTSTYLE_NORMAL,wxBOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    rankList->SetFont(rankListFont);
    BoxSizer6->Add(rankList, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    BoxSizer1->Add(BoxSizer6, 0, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Panel1->SetSizer(BoxSizer1);
    BoxSizer1->Fit(Panel1);
    BoxSizer1->SetSizeHints(Panel1);
    Panel3 = new wxPanel(Notebook1, ID_PANEL3, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL3"));
    BoxSizer4 = new wxBoxSizer(wxVERTICAL);
    MunkresChoice = new wxChoice(Panel3, ID_CHOICE3, wxDefaultPosition, wxDefaultSize, 0, 0, 0, wxDefaultValidator, _T("ID_CHOICE3"));
    BoxSizer4->Add(MunkresChoice, 0, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    munkresBitmap = new wxStaticBitmap(Panel3, ID_STATICBITMAP6, wxNullBitmap, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICBITMAP6"));
    BoxSizer4->Add(munkresBitmap, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Panel3->SetSizer(BoxSizer4);
    BoxSizer4->Fit(Panel3);
    BoxSizer4->SetSizeHints(Panel3);
    Notebook1->AddPage(Panel1, _("Captcha"), false);
    Notebook1->AddPage(Panel3, _("Munkres"), false);
    ToolBar1 = new wxToolBar(this, ID_TOOLBAR1, wxDefaultPosition, wxDefaultSize, wxTB_HORIZONTAL|wxNO_BORDER, _T("ID_TOOLBAR1"));
    ToolBarItem1 = ToolBar1->AddTool(ID_TOOLBARITEM3, _("Abrir"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FILE_OPEN")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString);
    ToolBarItem2 = ToolBar1->AddTool(ID_TOOLBARITEM2, _("Executar"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_LIST_VIEW")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString);
    ToolBarItem3 = ToolBar1->AddTool(ID_TOOLBARITEM4, _("Executar"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_TICK_MARK")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString);
    ToolBarItem4 = ToolBar1->AddTool(ID_TOOLBARITEM1, _("Sair"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_QUIT")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString);
    ToolBar1->Realize();
    SetToolBar(ToolBar1);
    fileDialog = new wxFileDialog(this, _("Select file"), wxEmptyString, wxEmptyString, wxFileSelectorDefaultWildcardStr, wxFD_DEFAULT_STYLE, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));

    Connect(ID_LISTBOX3,wxEVT_COMMAND_LISTBOX_SELECTED,(wxObjectEventFunction)&CaptchaWindow::OnlettersListSelect);
    Connect(ID_CHOICE3,wxEVT_COMMAND_CHOICE_SELECTED,(wxObjectEventFunction)&CaptchaFrame::OnMunkresChoiceSelect);
    Connect(ID_TOOLBARITEM3,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&CaptchaFrame::OnFileOpen);
    Connect(ID_TOOLBARITEM2,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&CaptchaFrame::OnRunClicked);
    Connect(ID_TOOLBARITEM4,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&CaptchaFrame::OnRunClicked2);
    Connect(ID_TOOLBARITEM1,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&CaptchaFrame::OnQuit);
    //*)
}

CaptchaFrame::~CaptchaFrame()
{
    //(*Destroy(CaptchaFrame)
    //*)
}

void CaptchaFrame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void CaptchaFrame::OnAbout(wxCommandEvent& event)
{
    wxString msg = wxbuildinfo(long_f);
    wxMessageBox(msg, _("Welcome to..."));
}

void CaptchaFrame::OnNotebook1PageChanged(wxNotebookEvent& event)
{
}
