/***************************************************************
 * Name:      CaptchaMain.h
 * Purpose:   Defines Application Frame
 * Author:    Diego Mira David ()
 * Created:   2008-11-30
 * Copyright: Diego Mira David ()
 * License:
 **************************************************************/

#ifndef CAPTCHAMAIN_H
#define CAPTCHAMAIN_H

//(*Headers(CaptchaFrame)
#include <wx/toolbar.h>
#include <wx/sizer.h>
#include <wx/notebook.h>
#include <wx/filedlg.h>
#include <wx/panel.h>
#include <wx/frame.h>
#include <wx/stattext.h>
#include <wx/choice.h>
#include <wx/statbmp.h>
#include <wx/listbox.h>
//*)

class CaptchaFrame: public wxFrame
{
    public:

        CaptchaFrame(wxWindow* parent,wxWindowID id = -1);
        virtual ~CaptchaFrame();

    private:

        //(*Handlers(CaptchaFrame)
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnNotebook1PageChanged(wxNotebookEvent& event);
        //*)

        //(*Identifiers(CaptchaFrame)
        static const long ID_CHOICE2;
        static const long ID_STATICBITMAP1;
        static const long ID_STATICBITMAP3;
        static const long ID_LISTBOX3;
        static const long ID_STATICTEXT1;
        static const long ID_LISTBOX4;
        static const long ID_LISTBOX5;
        static const long ID_PANEL1;
        static const long ID_CHOICE3;
        static const long ID_STATICBITMAP6;
        static const long ID_PANEL3;
        static const long ID_NOTEBOOK1;
        static const long ID_TOOLBARITEM3;
        static const long ID_TOOLBARITEM2;
        static const long ID_TOOLBARITEM4;
        static const long ID_TOOLBARITEM1;
        static const long ID_TOOLBAR1;
        //*)

        //(*Declarations(CaptchaFrame)
        wxListBox* wordsList;
        wxPanel* Panel1;
        wxStaticBitmap* munkresBitmap;
        wxStaticBitmap* bmpCountour;
        wxListBox* lettersList;
        wxChoice* MunkresChoice;
        wxStaticText* StaticText1;
        wxToolBarToolBase* ToolBarItem2;
        wxFileDialog* fileDialog;
        wxToolBar* ToolBar1;
        wxPanel* Panel3;
        wxStaticBitmap* bmpCaptcha;
        wxToolBarToolBase* ToolBarItem4;
        wxToolBarToolBase* ToolBarItem1;
        wxNotebook* Notebook1;
        wxToolBarToolBase* ToolBarItem3;
        wxListBox* rankList;
        wxChoice* letterChoice;
        //*)

        DECLARE_EVENT_TABLE()
};

#endif // CAPTCHAMAIN_H
