#include "CaptchaWindow.h"
#include "CannyEdgeDetector.h"
#include "ShapeContext.h"
#include "TPS.h"
#include "Image.h"
#include "Utility.h"
#include "Munkres.h"
#include <iostream>
#include <fstream>
#include <wx/string.h>
#include <wx/intl.h>
#include <wx/font.h>
#include <wx/bitmap.h>
#include <wx/image.h>
#include <wx/artprov.h>

//(*IdInit(CaptchaWindow)
const long CaptchaWindow::ID_CHOICE2 = wxNewId();
const long CaptchaWindow::ID_STATICBITMAP1 = wxNewId();
const long CaptchaWindow::ID_STATICBITMAP3 = wxNewId();
const long CaptchaWindow::ID_LISTBOX3 = wxNewId();
const long CaptchaWindow::ID_STATICTEXT1 = wxNewId();
const long CaptchaWindow::ID_LISTBOX4 = wxNewId();
const long CaptchaWindow::ID_LISTBOX5 = wxNewId();
const long CaptchaWindow::ID_PANEL1 = wxNewId();
const long CaptchaWindow::ID_CHOICE3 = wxNewId();
const long CaptchaWindow::ID_STATICBITMAP6 = wxNewId();
const long CaptchaWindow::ID_PANEL3 = wxNewId();
const long CaptchaWindow::ID_NOTEBOOK1 = wxNewId();
const long CaptchaWindow::ID_TOOLBARITEM3 = wxNewId();
const long CaptchaWindow::ID_TOOLBARITEM2 = wxNewId();
const long CaptchaWindow::ID_TOOLBARITEM4 = wxNewId();
const long CaptchaWindow::ID_TOOLBARITEM1 = wxNewId();
const long CaptchaWindow::ID_TOOLBAR1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(CaptchaWindow,wxFrame)
	//(*EventTable(CaptchaWindow)
	//*)
    EVT_TOOL(wxID_EXIT, CaptchaWindow::OnQuit)
END_EVENT_TABLE()


//*****************************************************************************/
//* Construtor da janela
//*****************************************************************************/
CaptchaWindow::CaptchaWindow(wxWindow* parent,wxWindowID id,const wxPoint& pos,const wxSize& size) {
    // Interface grafica. Codigo pelo wxSmith.
	Create(parent, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("wxID_ANY"));
	SetClientSize(wxSize(543,520));
    wxBoxSizer* BoxSizer4;
	wxBoxSizer* BoxSizer6;
	Notebook1 = new wxNotebook(this, ID_NOTEBOOK1, wxPoint(264,224), wxSize(543,480), 0, _T("ID_NOTEBOOK1"));
	CaptchaPanel = new wxPanel(Notebook1, ID_PANEL1, wxPoint(94,184), wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL1"));
	BoxSizer = new wxBoxSizer(wxHORIZONTAL);
	CaptchaBoxSizer = new wxBoxSizer(wxVERTICAL);
	letterChoice = new wxChoice(CaptchaPanel, ID_CHOICE2, wxDefaultPosition, wxDefaultSize, 0, 0, 0, wxDefaultValidator, _T("ID_CHOICE2"));
	CaptchaBoxSizer->Add(letterChoice, 0, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	bmpCaptcha = new wxStaticBitmap(CaptchaPanel, ID_STATICBITMAP1, wxNullBitmap, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICBITMAP1"));
	CaptchaBoxSizer->Add(bmpCaptcha, 0, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	bmpContour = new wxStaticBitmap(CaptchaPanel, ID_STATICBITMAP3, wxNullBitmap, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICBITMAP3"));
	CaptchaBoxSizer->Add(bmpContour, 0, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	lettersList = new wxListBox(CaptchaPanel, ID_LISTBOX3, wxDefaultPosition, wxSize(343,160), 0, 0, 0, wxDefaultValidator, _T("ID_LISTBOX3"));
	lettersList->SetBackgroundColour(wxColour(239,239,208));
	CaptchaBoxSizer->Add(lettersList, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BoxSizer->Add(CaptchaBoxSizer, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BoxSizer6 = new wxBoxSizer(wxVERTICAL);
	StaticText1 = new wxStaticText(CaptchaPanel, ID_STATICTEXT1, _("Palavras possíveis:         "), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	BoxSizer6->Add(StaticText1, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	wordsList = new wxListBox(CaptchaPanel, ID_LISTBOX4, wxDefaultPosition, wxDefaultSize, 0, 0, wxLB_SORT|wxSIMPLE_BORDER, wxDefaultValidator, _T("ID_LISTBOX4"));
	BoxSizer6->Add(wordsList, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	rankList = new wxListBox(CaptchaPanel, ID_LISTBOX5, wxDefaultPosition, wxDefaultSize, 0, 0, 0, wxDefaultValidator, _T("ID_LISTBOX5"));
	wxFont rankListFont(12,wxSWISS,wxFONTSTYLE_NORMAL,wxBOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
	rankList->SetFont(rankListFont);
	BoxSizer6->Add(rankList, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BoxSizer->Add(BoxSizer6, 0, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	CaptchaPanel->SetSizer(BoxSizer);
	BoxSizer->Fit(CaptchaPanel);
	BoxSizer->SetSizeHints(CaptchaPanel);
	MunkresPanel = new wxPanel(Notebook1, ID_PANEL3, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL3"));
	BoxSizer4 = new wxBoxSizer(wxVERTICAL);
	MunkresChoice = new wxChoice(MunkresPanel, ID_CHOICE3, wxDefaultPosition, wxDefaultSize, 0, 0, 0, wxDefaultValidator, _T("ID_CHOICE3"));
	BoxSizer4->Add(MunkresChoice, 0, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	munkresBitmap = new wxStaticBitmap(MunkresPanel, ID_STATICBITMAP6, wxNullBitmap, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICBITMAP6"));
	BoxSizer4->Add(munkresBitmap, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	MunkresPanel->SetSizer(BoxSizer4);
	BoxSizer4->Fit(MunkresPanel);
	BoxSizer4->SetSizeHints(MunkresPanel);
	Notebook1->AddPage(CaptchaPanel, _("Captcha"), false);
	Notebook1->AddPage(MunkresPanel, _("Munkres"), false);
	ToolBar1 = new wxToolBar(this, ID_TOOLBAR1, wxDefaultPosition, wxDefaultSize, wxTB_HORIZONTAL|wxNO_BORDER, _T("ID_TOOLBAR1"));
	ToolBarItem1 = ToolBar1->AddTool(ID_TOOLBARITEM3, _("Abrir"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FILE_OPEN")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString);
	ToolBarItem2 = ToolBar1->AddTool(ID_TOOLBARITEM2, _("Executar"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_LIST_VIEW")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString);
	ToolBarItem3 = ToolBar1->AddTool(ID_TOOLBARITEM4, _("Executar"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_TICK_MARK")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString);
	ToolBarItem4 = ToolBar1->AddTool(ID_TOOLBARITEM1, _("Sair"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_QUIT")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString);
	ToolBar1->Realize();
	SetToolBar(ToolBar1);
	fileDialog = new wxFileDialog(this, _("Select file"), wxEmptyString, wxEmptyString, wxFileSelectorDefaultWildcardStr, wxFD_DEFAULT_STYLE, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));

	Connect(ID_LISTBOX3,wxEVT_COMMAND_LISTBOX_SELECTED,(wxObjectEventFunction)&CaptchaWindow::OnlettersListSelect);
	Connect(ID_LISTBOX4,wxEVT_COMMAND_LISTBOX_SELECTED,(wxObjectEventFunction)&CaptchaWindow::OnwordsListSelect);
	Connect(ID_CHOICE2,wxEVT_COMMAND_CHOICE_SELECTED,(wxObjectEventFunction)&CaptchaWindow::OnletterChoiceSelect);
	Connect(ID_CHOICE3,wxEVT_COMMAND_CHOICE_SELECTED,(wxObjectEventFunction)&CaptchaWindow::OnMunkresChoiceSelect);
	Connect(ID_TOOLBARITEM3,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&CaptchaWindow::OnFileOpen);
	Connect(ID_TOOLBARITEM2,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&CaptchaWindow::OnRunClicked);
	Connect(ID_TOOLBARITEM4,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&CaptchaWindow::OnRunClicked2);
	Connect(ID_TOOLBARITEM1,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&CaptchaWindow::OnQuit);
	//*)

    // Carrega as imagens de treinamento
    char letter = 'a';
    for (int i = 0; i < 26; i++) {
        std::ostringstream fileName;
        fileName << "training/" << letter << ".jpg";
        trainingImages.push_back(new Image(fileName.str()));
        letter++;
    }
    solver.SetTrainingImages(trainingImages);

    // Preenche os controles wxChoice com as letras
    for (int i = 0; i < 26; i++) {
		letterChoice->Append(wxString::Format(wxT("%c"),'a'+i));
		MunkresChoice->Append(wxString::Format(wxT("%c"),'a'+i));
    }

}

//*****************************************************************************/
//* Quando da seleção de uma letra na lista, faz a marcação do ponto na imagem.
//*****************************************************************************/
void CaptchaWindow::OnlettersListSelect(wxCommandEvent& event) {
    int sel = event.GetInt();
    int x = tuples[sel].get<2>().x;
    int y = tuples[sel].get<2>().y;

    wxBitmap bmp = img->getContourBitmap();
    wxMemoryDC dc;
    dc.SelectObject(bmp);
    dc.SetPen(wxPen(*wxRED, 1, wxSOLID));
    dc.SetBrush(wxBrush(*wxRED, wxSOLID));
    dc.DrawCircle(x, y, 3);
    bmpContour->SetBitmap(bmp);

}

//*****************************************************************************/
//* Abertura de arquivo
//*****************************************************************************/
void CaptchaWindow::OnFileOpen(wxCommandEvent& event) {
    if (fileDialog->ShowModal() == wxID_OK) {
        std::string file(fileDialog->GetPath().mb_str(wxConvUTF8));
        img = new Image(file);
        solver.SetImage(img);
        wxImage* original = new wxImage(wxString(file.c_str(),wxConvUTF8));
        bmpCaptcha->SetBitmap(wxBitmap(*original));
        bmpContour->SetBitmap(img->getContourBitmap());
        wordsList->Clear();
        lettersList->Clear();
        rankList->Clear();
        BoxSizer->Fit(CaptchaPanel);
    }

}


//*****************************************************************************/
//* Executa o algoritmo para obter o conjunto de palavras possiveis
//*****************************************************************************/
void CaptchaWindow::OnRunClicked(wxCommandEvent& event) {
    std::vector<Point> points;

    // Le palavras do dicionario
    std::vector<std::string> words;
    std::ifstream arq("dictionary");
    std::string word;
    while (! arq.eof()) {
        arq >> word;
        if (!arq.eof())
            words.push_back(word);
    }

    if (img == NULL) return;

    for (int i = 0; i < 26; i++)
        LETTERS[i].clear();

        // Obtem a lista de hipoteses
        tuples = solver.getTuples(LETTERS,'i');

        // Obtem o conjunto de palavras possiveis
        wordslist = solver.getWordslist(tuples, words);

        // Insere a lista de hipoteses para exibição na janela
        lettersList->Clear();
        for (unsigned int i = 0; i < tuples.size(); i++) {
            wxString str;
            str.Printf(wxT("Distancia = %f Letra: %c Posicao: (%d,%d)"), \
            tuples[i].get<0>(), tuples[i].get<1>(), tuples[i].get<2>().x,tuples[i].get<2>().y);
            lettersList->Append(str);
        }

        // Exibe as palavras possiveis
        wordsList->Clear();
        for (unsigned int i = 0; i < wordslist.size(); i++) {
            wordsList->Append(wxString(wordslist[i].c_str(), wxConvUTF8));
        }
        StaticText1->SetLabel(wxString::Format(wxT("Palavras possíveis: %d/%d"), wordslist.size(), words.size()));

}

//*****************************************************************************/
//* Executa a etapa mais custosa de ordenação das palavras restantes
//*****************************************************************************/
void CaptchaWindow::OnRunClicked2(wxCommandEvent& event) {
    std::vector< tuple<double,std::string> > words;
    words = solver.solve(wordslist);
    for (unsigned int i = 0; i < words.size(); i++) {
        wxString strNum;
        strNum.Printf(wxT(" %2d "),i+1);
        rankList->Append(strNum+wxString(words[i].get<1>().c_str(), wxConvUTF8));
    }

}

//*****************************************************************************/
//* Fecha a janela
//*****************************************************************************/
void CaptchaWindow::OnQuit(wxCommandEvent& event) {
    Close();
}

//*****************************************************************************/
//* Marca os pontos correspondentes aos melhores shape contexts para a
//* letra selecionada.
//*****************************************************************************/
void CaptchaWindow::OnletterChoiceSelect(wxCommandEvent& event) {
    int sel = event.GetInt();
    if (img != NULL) {
        wxBitmap bmp = img->getContourBitmap();
        wxMemoryDC dc;

        dc.SelectObject(bmp);
        dc.SetPen(wxPen(*wxRED, 1, wxSOLID));
        dc.SetBrush(wxBrush(*wxRED, wxSOLID));

        for (unsigned int i = 0; i < LETTERS[sel].size(); i++) {
            Point pt = LETTERS[sel][i];
            dc.DrawCircle(pt.x, pt.y, 2);
        }

        bmpContour->SetBitmap(bmp);
    }
}

//*****************************************************************************/
//* Executa e exibe o algoritmo Munkres para uma letra selecionada.
//*****************************************************************************/
void CaptchaWindow::OnMunkresChoiceSelect(wxCommandEvent& event) {
    int sel = event.GetInt();
    if (img != NULL && trainingImages[sel] != NULL) {
        wxMemoryDC dc;
        Munkres munkresSolver;

        std::vector<Point> points = trainingImages[sel]->getAllPoints();
        int m = median(points);
        trainingImages[sel]->computeShapeContexts(50,m);
        img->computeShapeContexts(200,m);
        std::vector<ShapeContext*> SC1 = trainingImages[sel]->getShapeContexts();
        std::vector<ShapeContext*> SC2 = img->getShapeContexts();

        matrix<double> Cost (SC1.size(),SC2.size());
        for (unsigned int i = 0; i < SC1.size(); i++) {
            ShapeContext *sc1 = SC1[i];
            for (unsigned int j = 0; j < SC2.size(); j++) {
                ShapeContext *sc2 = SC2[j];
                Cost(i,j) = sc1->distance(sc2);
            }
        }

        std::vector<Point> pts1;
        std::vector<Point> pts2;

        for (unsigned int i = 0; i < SC1.size(); i++)
            pts1.push_back(SC1[i]->getPoint());

        for (unsigned int i = 0; i < SC2.size(); i++)
            pts2.push_back(SC2[i]->getPoint());

        vector<int> results(600);
        munkresSolver.compute(Cost,results);

        double optimalCost = 0;
        for (unsigned int i = 0; i < Cost.size1(); i++)
            optimalCost += Cost(i,results(i));

        int w = img->getWidth() + trainingImages[sel]->getWidth() + 100;
        int h = img->getHeight() + trainingImages[sel]->getHeight() + 100;
        wxBitmap bmpC = wxBitmap(w,h);
        dc.SelectObject(bmpC);

        dc.Clear();

        dc.SetBrush(wxBrush(*wxBLACK, wxSOLID));
        for (unsigned i = 0; i < pts2.size(); i++) {
            Point pt2 = pts2[i];
            dc.DrawCircle(pt2.x+100, pt2.y+100, 2);
        }

        for (unsigned int i = 0; i < Cost.size1(); i++) {
            Point pt1 = pts1[i];
            Point pt2 = pts2[results(i)];
            dc.SetBrush(wxBrush(*wxBLUE, wxSOLID));
            dc.DrawCircle(pt1.x, pt1.y, 2);
            dc.SetBrush(wxBrush(*wxGREEN, wxSOLID));
            dc.DrawCircle(pt2.x+100, pt2.y+100, 2);
            dc.DrawLine(pt1.x, pt1.y, pt2.x+100, pt2.y+100);
        }
        munkresBitmap->SetBitmap(bmpC);
    }
}

//*****************************************************************************/
//* Exibe na imagem do captcha todas as ocorrências das letras da
//* palavra selecionada
//*****************************************************************************/
void CaptchaWindow::OnwordsListSelect(wxCommandEvent& event) {
    wxBitmap bmp = img->getContourBitmap();
    wxMemoryDC dc;

    dc.SelectObject(bmp);

    wxFont font = *wxNORMAL_FONT;
    font.SetPointSize(15);
    font.SetWeight(wxFONTWEIGHT_BOLD);
    dc.SetFont(font);

    wxString word = wordsList->GetStringSelection();
    for (unsigned int i = 0; i < word.Len(); i++) {
        char c = word.GetChar(i);
        dc.SetTextForeground(*wxGREEN);
        for (unsigned int j = 0; j < tuples.size()/2; j++) {
            if (c == tuples[j].get<1>())
                dc.DrawText(wxString::Format(wxT("%c"),c),tuples[j].get<2>().x,tuples[j].get<2>().y-10);
        }
        dc.SetTextForeground(*wxRED);
        for (unsigned int j = tuples.size()/2; j < tuples.size(); j++) {
            if (c == tuples[j].get<1>())
                dc.DrawText(wxString::Format(wxT("%c"),c),tuples[j].get<2>().x,tuples[j].get<2>().y-10);
        }
    }

    bmpContour->SetBitmap(bmp);
}
