#ifndef CAPTCHAWINDOW_H
#define CAPTCHAWINDOW_H


#include <wx/toolbar.h>
#include <wx/sizer.h>
#include <wx/notebook.h>
#include <wx/filedlg.h>
#include <wx/panel.h>
#include <wx/frame.h>
#include <wx/stattext.h>
#include <wx/choice.h>
#include <wx/statbmp.h>
#include <wx/listbox.h>
#include "Image.h"
#include "EZGimpySolver.h"

class Point;

class CaptchaWindow: public wxFrame {
	public:
		CaptchaWindow(wxWindow* parent,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);

		//(*Declarations(CaptchaWindow)
		wxListBox* wordsList;
		wxStaticBitmap* munkresBitmap;
		wxPanel* MunkresPanel;
		wxPanel* CaptchaPanel;
		wxListBox* lettersList;
		wxChoice* MunkresChoice;
		wxStaticText* StaticText1;
		wxToolBarToolBase* ToolBarItem2;
		wxFileDialog* fileDialog;
		wxToolBar* ToolBar1;
		wxStaticBitmap* bmpCaptcha;
		wxBoxSizer* BoxSizer;
		wxBoxSizer* CaptchaBoxSizer;
		wxToolBarToolBase* ToolBarItem4;
		wxToolBarToolBase* ToolBarItem1;
		wxNotebook* Notebook1;
		wxStaticBitmap* bmpContour;
		wxToolBarToolBase* ToolBarItem3;
		wxListBox* rankList;
		wxChoice* letterChoice;
		//*)

	protected:

		//(*Identifiers(CaptchaWindow)
		static const long ID_CHOICE2;
		static const long ID_STATICBITMAP1;
		static const long ID_STATICBITMAP3;
		static const long ID_LISTBOX3;
		static const long ID_STATICTEXT1;
		static const long ID_LISTBOX4;
		static const long ID_LISTBOX5;
		static const long ID_PANEL1;
		static const long ID_CHOICE3;
		static const long ID_STATICBITMAP6;
		static const long ID_PANEL3;
		static const long ID_NOTEBOOK1;
		static const long ID_TOOLBARITEM3;
		static const long ID_TOOLBARITEM2;
		static const long ID_TOOLBARITEM4;
		static const long ID_TOOLBARITEM1;
		static const long ID_TOOLBAR1;
		//*)

	private:

        Image *img;
        EZGimpySolver solver;
        std::vector<DistanceAndLetter> tuples;
        std::vector<std::string> wordslist;
        std::vector<std::string> wordslist2;
        std::vector<Point> LETTERS[26];
        std::vector<Image*> trainingImages;

		//(*Handlers(CaptchaWindow)
		void OnPointsListSelect(wxCommandEvent& event);
		void OnlettersListItemSelect(wxListEvent& event);
		void OnlettersListSelect(wxCommandEvent& event);
		void OnFileOpen(wxCommandEvent& event);
		void OnRunClicked(wxCommandEvent& event);
		void OnRunClicked2(wxCommandEvent& event);
		void OnQuit(wxCommandEvent& event);
		void OnletterChoiceSelect(wxCommandEvent& event);
		void OnNotebook1PageChanged(wxNotebookEvent& event);
		void OnMunkresChoiceSelect(wxCommandEvent& event);
		void OnwordsListSelect(wxCommandEvent& event);
		//*)

		DECLARE_EVENT_TABLE()
};

#endif
