#ifndef GENERALIZEDSHAPECONTEXT_H
#define GENERALIZEDSHAPECONTEXT_H


#include <wx/wx.h>
#include <vector>
#include <boost/numeric/ublas/vector.hpp>
#include <boost/numeric/ublas/matrix.hpp>
#include "Point.h"
#include "ShapeContext.h"

using namespace boost::numeric::ublas;

class GeneralizedShapeContext: public ShapeContext {
    public:
        GeneralizedShapeContext(Point point) : ShapeContext(point) {
            histogram = matrix<Tangent> (5,12);
        };
        virtual void compute(std::vector<Point> seq, double median);
        Tangent get(int i, int j);
        virtual double distance(ShapeContext *sc);

    private:
        matrix<Tangent> histogram;
};

#endif // GENERALIZEDSHAPECONTEXT_H
