#ifndef IMAGE_H
#define IMAGE_H

#include <vector>
#include <boost/shared_ptr.hpp>
#include "wx/wx.h"
#include "Point.h"
#include "ShapeContext.h"

class Image {
    public:
        Image(std::string file);
        wxBitmap getBitmap();
        std::vector<Point> getPoints(unsigned int sampleSize);
        wxBitmap getContourPointsBitmap(unsigned int sampleSize);
        wxBitmap getContourBitmap();
        std::vector<ShapeContext*> getShapeContexts();
        void computeShapeContexts(unsigned int n, double median);
        int getHeight();
        int getWidth();
        std::vector<Point> getAllPoints();
        wxImage getOriginal();
        std::string getFile();
        static void setSigma(float sigma);

    protected:
    private:
        wxImage *img;
        wxImage original;
        std::vector<ShapeContext*> SC;
        std::vector<Point> allPoints;
        std::string file;
        wxBitmap contour;
        boost::shared_ptr<wxImage> imgContour;
};

#endif // IMAGE_H
