#ifndef IMAGESDIALOG_H
#define IMAGESDIALOG_H

//(*Headers(ImagesDialog)
#include <wx/bmpbuttn.h>
#include <wx/dialog.h>
#include <wx/sizer.h>
#include <wx/listctrl.h>
#include <wx/button.h>
#include <wx/dirdlg.h>
#include <wx/filedlg.h>
#include <wx/panel.h>
//*)

#include <vector>
#include "Image.h"

class Application;

class ImagesDialog: public wxDialog
{
	public:

		ImagesDialog(wxWindow* parent,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
		virtual ~ImagesDialog();

		//(*Declarations(ImagesDialog)
		wxPanel* Panel1;
		wxButton* ButtonOK;
		wxFileDialog* fileDialog;
		wxBitmapButton* btnAddFile;
		wxBitmapButton* btnAddDir;
		wxDirDialog* dirDialog;
		wxListCtrl* ListCtrl;
		wxBitmapButton* BitmapButton1;
		//*)

		std::vector<Image*> getImages();

	protected:

		//(*Identifiers(ImagesDialog)
		static const long ID_BITMAPBUTTON1;
		static const long ID_BITMAPBUTTON2;
		static const long ID_BITMAPBUTTON3;
		static const long ID_LISTCTRL1;
		static const long ID_BUTTON1;
		static const long ID_PANEL1;
		//*)

	private:

		//(*Handlers(ImagesDialog)
		void OnButtonOKClick(wxCommandEvent& event);
		void OnBitmapButton1Click(wxCommandEvent& event);
		void OnbtnAddFileClick(wxCommandEvent& event);
		void OnbtnAddDirClick(wxCommandEvent& event);
		void OnbtnClearClick(wxCommandEvent& event);
		//*)

		Application *app;
		static wxImageList *imageList;
		static std::vector<Image*> images;

		DECLARE_EVENT_TABLE()
};


#endif
