#include "MainWindow.h"
#include "ShapeContextWindow.h"
#include "ShapeContext.h"
#include "Image.h"
#include "Utility.h"
#include "ImagesDialog.h"
#include "Application.h"
#include "TPS.h"
#include "Pruning.h"
#include <wx/imaglist.h>
#include "boost/tuple/tuple.hpp"
#include "wx/wx.h"
#include <wx/utils.h>
#include <wx/process.h>
#include <wx/gdicmn.h>
#include <wx/string.h>
#include <wx/intl.h>
#include <wx/bitmap.h>
#include <wx/image.h>
#include <wx/artprov.h>

//(*IdInit(MainWindow)
const long MainWindow::ID_STATICBITMAP1 = wxNewId();
const long MainWindow::ID_STATICBITMAP5 = wxNewId();
const long MainWindow::ID_PANEL1 = wxNewId();
const long MainWindow::ID_STATICBITMAP2 = wxNewId();
const long MainWindow::ID_STATICBITMAP9 = wxNewId();
const long MainWindow::ID_STATICBITMAP6 = wxNewId();
const long MainWindow::ID_STATICBITMAP10 = wxNewId();
const long MainWindow::ID_PANEL2 = wxNewId();
const long MainWindow::ID_STATICTEXT1 = wxNewId();
const long MainWindow::ID_STATICTEXT2 = wxNewId();
const long MainWindow::ID_GRID2 = wxNewId();
const long MainWindow::ID_PANEL4 = wxNewId();
const long MainWindow::ID_STATICBITMAP13 = wxNewId();
const long MainWindow::ID_PANEL7 = wxNewId();
const long MainWindow::ID_LISTCTRL1 = wxNewId();
const long MainWindow::ID_PANEL5 = wxNewId();
const long MainWindow::ID_NOTEBOOK1 = wxNewId();
const long MainWindow::ID_MENUITEM2 = wxNewId();
const long MainWindow::ID_TOOLBARITEM1 = wxNewId();
const long MainWindow::ID_TOOLBARITEM5 = wxNewId();
const long MainWindow::ID_TOOLBARITEM3 = wxNewId();
const long MainWindow::ID_TOOLBARITEM2 = wxNewId();
const long MainWindow::ID_TOOLBAR1 = wxNewId();
const long MainWindow::ID_STATUSBAR1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(MainWindow,wxFrame)
	//(*EventTable(MainWindow)
	//*)
    EVT_MENU(wxID_EXIT, MainWindow::OnQuit)
    EVT_TOOL(wxID_EXIT, MainWindow::OnQuit)
END_EVENT_TABLE()

typedef boost::tuple<double, wxString,wxBitmap> tTuple;
bool compare (tTuple a, tTuple b) { return (a.get<0>() < b.get<0>()); }

MainWindow::MainWindow(wxWindow* parent,wxWindowID id,const wxPoint& pos,const wxSize& size) {
    app = (Application *) wxTheApp;

	//(*Initialize(MainWindow)
	wxMenuItem* MenuItemExit;
	wxBoxSizer* BoxSizer9;
	wxBoxSizer* BoxSizer8;
	wxBoxSizer* BoxSizer1;
	wxBoxSizer* BoxSizer12;

	Create(parent, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("wxID_ANY"));
	SetClientSize(wxSize(800,500));
	SetMinSize(wxSize(800,400));
	hBox = new wxBoxSizer(wxHORIZONTAL);
	Notebook1 = new wxNotebook(this, ID_NOTEBOOK1, wxDefaultPosition, wxSize(695,500), 0, _T("ID_NOTEBOOK1"));
	ImagesPanel = new wxPanel(Notebook1, ID_PANEL1, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL1"));
	hBoxImages = new wxBoxSizer(wxHORIZONTAL);
	bitmapOriginal = new wxStaticBitmap(ImagesPanel, ID_STATICBITMAP1, wxNullBitmap, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICBITMAP1"));
	hBoxImages->Add(bitmapOriginal, 0, wxALL|wxALIGN_LEFT|wxALIGN_TOP, 5);
	bitmapOriginal2 = new wxStaticBitmap(ImagesPanel, ID_STATICBITMAP5, wxNullBitmap, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICBITMAP5"));
	hBoxImages->Add(bitmapOriginal2, 0, wxALL|wxALIGN_LEFT|wxALIGN_TOP, 5);
	ImagesPanel->SetSizer(hBoxImages);
	hBoxImages->Fit(ImagesPanel);
	hBoxImages->SetSizeHints(ImagesPanel);
	PointsPanel = new wxPanel(Notebook1, ID_PANEL2, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL2"));
	PointsBoxSizer = new wxBoxSizer(wxVERTICAL);
	BoxSizer8 = new wxBoxSizer(wxHORIZONTAL);
	bitmapContour1 = new wxStaticBitmap(PointsPanel, ID_STATICBITMAP2, wxNullBitmap, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICBITMAP2"));
	BoxSizer8->Add(bitmapContour1, 0, wxALL|wxALIGN_LEFT|wxALIGN_TOP, 5);
	bitmapPoints1 = new wxStaticBitmap(PointsPanel, ID_STATICBITMAP9, wxNullBitmap, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICBITMAP9"));
	BoxSizer8->Add(bitmapPoints1, 0, wxALL|wxALIGN_TOP|wxALIGN_CENTER_HORIZONTAL, 5);
	PointsBoxSizer->Add(BoxSizer8, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BoxSizer9 = new wxBoxSizer(wxHORIZONTAL);
	bitmapContour2 = new wxStaticBitmap(PointsPanel, ID_STATICBITMAP6, wxNullBitmap, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICBITMAP6"));
	BoxSizer9->Add(bitmapContour2, 0, wxALL|wxALIGN_LEFT|wxALIGN_TOP, 5);
	bitmapPoints2 = new wxStaticBitmap(PointsPanel, ID_STATICBITMAP10, wxNullBitmap, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICBITMAP10"));
	BoxSizer9->Add(bitmapPoints2, 0, wxALL|wxALIGN_TOP|wxALIGN_CENTER_HORIZONTAL, 5);
	PointsBoxSizer->Add(BoxSizer9, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	PointsPanel->SetSizer(PointsBoxSizer);
	PointsBoxSizer->Fit(PointsPanel);
	PointsBoxSizer->SetSizeHints(PointsPanel);
	CostPanel = new wxPanel(Notebook1, ID_PANEL4, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL4"));
	BoxSizer1 = new wxBoxSizer(wxVERTICAL);
	lblOptimalCost = new wxStaticText(CostPanel, ID_STATICTEXT1, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
	BoxSizer1->Add(lblOptimalCost, 0, wxALL|wxALIGN_LEFT|wxALIGN_TOP, 5);
	lblBendingEnergy = new wxStaticText(CostPanel, ID_STATICTEXT2, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT2"));
	BoxSizer1->Add(lblBendingEnergy, 0, wxALL|wxALIGN_LEFT|wxALIGN_TOP, 5);
	costGrid = new wxGrid(CostPanel, ID_GRID2, wxDefaultPosition, wxDefaultSize, 0, _T("ID_GRID2"));
	costGrid->CreateGrid(1,1);
	BoxSizer1->Add(costGrid, 1, wxALL|wxEXPAND|wxALIGN_LEFT|wxALIGN_TOP, 5);
	CostPanel->SetSizer(BoxSizer1);
	BoxSizer1->Fit(CostPanel);
	BoxSizer1->SetSizeHints(CostPanel);
	CorrespondencePanel = new wxPanel(Notebook1, ID_PANEL7, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL7"));
	BoxSizer12 = new wxBoxSizer(wxHORIZONTAL);
	correspondenceBitmap = new wxStaticBitmap(CorrespondencePanel, ID_STATICBITMAP13, wxNullBitmap, wxPoint(224,160), wxDefaultSize, 0, _T("ID_STATICBITMAP13"));
	BoxSizer12->Add(correspondenceBitmap, 0, wxALL|wxALIGN_LEFT|wxALIGN_TOP, 5);
	CorrespondencePanel->SetSizer(BoxSizer12);
	BoxSizer12->Fit(CorrespondencePanel);
	BoxSizer12->SetSizeHints(CorrespondencePanel);
	RankingPanel = new wxPanel(Notebook1, ID_PANEL5, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL5"));
	BoxSizer11 = new wxBoxSizer(wxHORIZONTAL);
	ListCtrl = new wxListCtrl(RankingPanel, ID_LISTCTRL1, wxPoint(8,8), wxSize(261,157), wxLC_LIST|wxSUNKEN_BORDER|wxVSCROLL, wxDefaultValidator, _T("ID_LISTCTRL1"));
	ListCtrl->SetBackgroundColour(wxColour(235,237,211));
	BoxSizer11->Add(ListCtrl, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	RankingPanel->SetSizer(BoxSizer11);
	BoxSizer11->Fit(RankingPanel);
	BoxSizer11->SetSizeHints(RankingPanel);
	Notebook1->AddPage(ImagesPanel, _("Images"), false);
	Notebook1->AddPage(PointsPanel, _("Points"), false);
	Notebook1->AddPage(CostPanel, _("Cost"), false);
	Notebook1->AddPage(CorrespondencePanel, _("Correspondence"), false);
	Notebook1->AddPage(RankingPanel, _("Ranking"), false);
	hBox->Add(Notebook1, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(hBox);
	menuBar = new wxMenuBar();
	fileMenu = new wxMenu();
	MenuItemSC = new wxMenuItem(fileMenu, ID_MENUITEM2, _("Shape Context"), wxEmptyString, wxITEM_NORMAL);
	fileMenu->Append(MenuItemSC);
	MenuItemSC->Enable(false);
	MenuItemExit = new wxMenuItem(fileMenu, wxID_EXIT, _("Exit"), wxEmptyString, wxITEM_NORMAL);
	fileMenu->Append(MenuItemExit);
	menuBar->Append(fileMenu, _("File"));
	SetMenuBar(menuBar);
	ToolBar1 = new wxToolBar(this, ID_TOOLBAR1, wxDefaultPosition, wxDefaultSize, wxTB_HORIZONTAL|wxNO_BORDER, _T("ID_TOOLBAR1"));
	ToolBarItem1 = ToolBar1->AddTool(ID_TOOLBARITEM1, _("Abrir"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FILE_OPEN")),wxART_BUTTON), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString);
	ToolBarItem2 = ToolBar1->AddTool(ID_TOOLBARITEM5, _("Abrir"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_LIST_VIEW")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString);
	ToolBar1->AddSeparator();
	ToolBarItem3 = ToolBar1->AddTool(ID_TOOLBARITEM3, _("Executar Várias"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_TICK_MARK")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString);
	ToolBar1->AddSeparator();
	ToolBarItem4 = ToolBar1->AddTool(ID_TOOLBARITEM2, _("Sair"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_QUIT")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString);
	ToolBar1->Realize();
	SetToolBar(ToolBar1);
	StatusBar1 = new wxStatusBar(this, ID_STATUSBAR1, 0, _T("ID_STATUSBAR1"));
	int __wxStatusBarWidths_1[1] = { -10 };
	int __wxStatusBarStyles_1[1] = { wxSB_NORMAL };
	StatusBar1->SetFieldsCount(1,__wxStatusBarWidths_1);
	StatusBar1->SetStatusStyles(1,__wxStatusBarStyles_1);
	SetStatusBar(StatusBar1);
	fileDialog = new wxFileDialog(this, _("Select file"), wxEmptyString, wxEmptyString, wxFileSelectorDefaultWildcardStr, wxFD_DEFAULT_STYLE, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
	DirDialog1 = new wxDirDialog(this, _("Select directory"), wxEmptyString, wxDD_DEFAULT_STYLE, wxDefaultPosition, wxDefaultSize, _T("wxDirDialog"));
	hBox->SetSizeHints(this);

	Connect(ID_MENUITEM2,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&MainWindow::OnMenuItemSCSelected);
	Connect(ID_TOOLBARITEM1,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&MainWindow::OnFileOpen);
	Connect(ID_TOOLBARITEM5,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&MainWindow::OnFileOpen2);
	Connect(ID_TOOLBARITEM3,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&MainWindow::OnRunClick);
	Connect(ID_TOOLBARITEM2,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&MainWindow::OnQuit);
	//*)

    imageList = new wxImageList(400, 400);
    ListCtrl->SetImageList(imageList, wxIMAGE_LIST_SMALL);
    ListCtrl->Arrange(wxLIST_ALIGN_SNAP_TO_GRID);

    costGrid->AppendRows(SAMPLE_SIZE);
    costGrid->AppendCols(SAMPLE_SIZE);

    CorrespondencePanel->Show(false);
    CostPanel->Show(false);
}


/*****************************************************************************/
/* Fecha a janela principal
/*****************************************************************************/
void MainWindow::OnQuit(wxCommandEvent& event) {
    Close();
}

/*****************************************************************************/
/* Abre uma imagem de consulta
/*****************************************************************************/
void MainWindow::OnFileOpen(wxCommandEvent& event) {
    if (fileDialog->ShowModal() == wxID_OK) {
        std::string file(fileDialog->GetPath().mb_str(wxConvUTF8));
        Image *img = new Image(file);
        app->setImage1(img);
        PointsBoxSizer->Fit(PointsPanel);
        MenuItemSC->Enable(true);
    }
}

/*****************************************************************************/
/* Executa o algoritmo
/*****************************************************************************/
void MainWindow::OnRunClick(wxCommandEvent& event) {
    long double optimalCost;
    long double total;
    int index;

    bitmapOriginal2->SetBitmap(wxNullBitmap);
    bitmapContour2->SetBitmap(wxNullBitmap);

    wxString s;
    std::vector<tTuple> v;
    std::vector<Image*> imgs = app->getImages();

    if (imgs.size() == 1) {
        CorrespondencePanel->Show(true);
        CostPanel->Show(true);
    }
    else {
        CorrespondencePanel->Show(false);
        CostPanel->Show(false);
    }

    Pruning pruning;
    pruning.setImage(app->getImage());
    pruning.setImages(imgs);
    std::vector<DistanceAndImage> distances = pruning.run();
    for(unsigned int i = 0; i < distances.size(); i++) {
        Image *img = distances[i].get<1>();
        std::cout << "Distancia = " << distances[i].get<0>() << " " << img->getFile() << std::endl;
    }

    int num = distances.size();
    if (num > 10)
        num = 10;

    for(int i = 0; i < num; i++) {
        Image *img = distances[i].get<1>();
        app->setImage2(img);
        app->run();
        optimalCost = app->getOptimalCost();
        v.push_back(boost::make_tuple((double)optimalCost,s, wxBitmap(img->getOriginal())));
    }

    sort(v.begin(), v.end(), compare);

    imageList->RemoveAll();
    ListCtrl->ClearAll();
    for (int i = 0; i < num; i++) {
        index = imageList->Add(v[i].get<2>());
        s.Printf(wxT("%.2f"),v[i].get<0>());
        ListCtrl->InsertItem(i,s,index);
    }

}

/*****************************************************************************/
/* Exibe a janela que permite inserir imagens ao conjunto
/*****************************************************************************/
void MainWindow::OnFileOpen2(wxCommandEvent& event) {
    ImagesDialog *imagesDialog = new ImagesDialog(0, 0, wxPoint(100,100),wxSize(500,300));
    imagesDialog->ShowModal();
}

void MainWindow::OnMenuItemSCSelected(wxCommandEvent& event) {
    ShapeContextWindow* scWindow = new ShapeContextWindow(0, 0, wxPoint(100,100),wxSize(500,300));
    scWindow->Show(true);
}
