#ifndef MainWindow_H
#define MainWindow_H

//(*Headers(MainWindow)
#include <wx/grid.h>
#include <wx/toolbar.h>
#include <wx/sizer.h>
#include <wx/listctrl.h>
#include <wx/notebook.h>
#include <wx/menu.h>
#include <wx/dirdlg.h>
#include <wx/filedlg.h>
#include <wx/panel.h>
#include <wx/statusbr.h>
#include <wx/frame.h>
#include <wx/stattext.h>
#include <wx/statbmp.h>
//*)

class Application;

class MainWindow: public wxFrame
{
	public:

		MainWindow(wxWindow* parent,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
		//(*Declarations(MainWindow)
		wxPanel* PointsPanel;
		wxMenuBar* menuBar;
		wxStaticBitmap* correspondenceBitmap;
		wxStaticBitmap* bitmapOriginal2;
		wxBoxSizer* PointsBoxSizer;
		wxStatusBar* StatusBar1;
		wxStaticBitmap* bitmapContour1;
		wxGrid* costGrid;
		wxPanel* CorrespondencePanel;
		wxPanel* RankingPanel;
		wxBoxSizer* BoxSizer11;
		wxBoxSizer* hBoxImages;
		wxDirDialog* DirDialog1;
		wxStaticBitmap* bitmapPoints2;
		wxToolBarToolBase* ToolBarItem2;
		wxFileDialog* fileDialog;
		wxMenuItem* MenuItemSC;
		wxPanel* CostPanel;
		wxStaticBitmap* bitmapPoints1;
		wxBoxSizer* hBox;
		wxToolBar* ToolBar1;
		wxStaticText* lblOptimalCost;
		wxToolBarToolBase* ToolBarItem4;
		wxToolBarToolBase* ToolBarItem1;
		wxStaticText* lblBendingEnergy;
		wxMenu* fileMenu;
		wxNotebook* Notebook1;
		wxToolBarToolBase* ToolBarItem3;
		wxStaticBitmap* bitmapContour2;
		wxListCtrl* ListCtrl;
		wxStaticBitmap* bitmapOriginal;
		wxPanel* ImagesPanel;
		//*)

	protected:

		//(*Identifiers(MainWindow)
		static const long ID_STATICBITMAP1;
		static const long ID_STATICBITMAP5;
		static const long ID_PANEL1;
		static const long ID_STATICBITMAP2;
		static const long ID_STATICBITMAP9;
		static const long ID_STATICBITMAP6;
		static const long ID_STATICBITMAP10;
		static const long ID_PANEL2;
		static const long ID_STATICTEXT1;
		static const long ID_STATICTEXT2;
		static const long ID_GRID2;
		static const long ID_PANEL4;
		static const long ID_STATICBITMAP13;
		static const long ID_PANEL7;
		static const long ID_LISTCTRL1;
		static const long ID_PANEL5;
		static const long ID_NOTEBOOK1;
		static const long ID_MENUITEM2;
		static const long ID_TOOLBARITEM1;
		static const long ID_TOOLBARITEM5;
		static const long ID_TOOLBARITEM3;
		static const long ID_TOOLBARITEM2;
		static const long ID_TOOLBAR1;
		static const long ID_STATUSBAR1;
		//*)

	private:
        Application *app;
        wxImageList *imageList;

		//(*Handlers(MainWindow)
		void OnlistaPontosSelect(wxCommandEvent& event);
		void OnQuit(wxCommandEvent& event);
		void OnFileOpen(wxCommandEvent& event);
		void OnNotebook1PageChanged(wxNotebookEvent& event);
		void OnNotebook1PageChanged1(wxNotebookEvent& event);
		void OnNotebook1PageChanged2(wxNotebookEvent& event);
		void OnRunClick(wxCommandEvent& event);
		void OnNotebook1PageChanged3(wxNotebookEvent& event);
		void OnPointsList2Select(wxCommandEvent& event);
		void OnTPSListBoxSelect(wxCommandEvent& event);
		void OnToolBarItem2Clicked(wxCommandEvent& event);
		void OnFileOpen2(wxCommandEvent& event);
		void OnMotion(wxMouseEvent& event);
		void OnDirDialog(wxCommandEvent& event);
		void OnMenuItemSCSelected(wxCommandEvent& event);
		void OnPointsListSelect(wxCommandEvent& event);
		//*)

		DECLARE_EVENT_TABLE()
};

#endif
