#ifndef ORIGINALSHAPECONTEXT_H
#define ORIGINALSHAPECONTEXT_H
#include "ShapeContext.h"
#include <boost/numeric/ublas/matrix.hpp>
using namespace boost::numeric::ublas;

class OriginalShapeContext : public ShapeContext {

    public:
        OriginalShapeContext(Point point) : ShapeContext(point) {};
        virtual void compute(std::vector<Point> seq, double median);
        virtual wxBitmap toBitmap();
        virtual void printString();
        virtual wxBitmap image(int width, int height, std::vector<Point> seq, double median);
        virtual double distance(ShapeContext *sc);
        double get(int i, int j);

    protected:
    private:
        matrix<double> histogram;

};

#endif // ORIGINALSHAPECONTEXT_H
