#include "Pruning.h"
#include "Utility.h"


/*****************************************************************************/
/* Define o conjunto de imagens
/*****************************************************************************/
void Pruning::setImages(std::vector<Image*> images) {
    this->images = images;
}

/*****************************************************************************/
/* Define a imagem
/*****************************************************************************/
void Pruning::setImage(Image* img) {
    this->img = img;
}

//*****************************************************************************/
//* Executa o algoritmo de filtragem
//* Devolve a lista de candidatos
//*****************************************************************************/
std::vector<DistanceAndImage> Pruning::run() {
    std::vector<DistanceAndImage> distances;
    double N;
    double d = 0;
    int num = 20;

    if (img == NULL || images.size() == 0)
        return distances;

    std::vector<ShapeContext*> SCShape[images.size()];
    double minValues[num][images.size()];
    img->computeShapeContexts(num, median(img->getAllPoints()));
    std::vector<ShapeContext*> SCQuery = img->getShapeContexts();

    for (unsigned int n = 0; n < images.size(); n++) {
        std::cout << "Imagem " << n << std::endl;
        images[n]->computeShapeContexts(SAMPLE_SIZE, median(images[n]->getAllPoints()));
        SCShape[n] = images[n]->getShapeContexts();
    }

    std::vector<CostAndIndices> scs[images.size()];

    // Para cada imagem
    for (unsigned int n = 0; n < images.size(); n++) {
        // Para cada SC da imagem de consulta
        for (unsigned int i = 0; i < SCQuery.size(); i++) {
            ShapeContext *scQuery = SCQuery[i];
            //Para cada SC da imagem
            ShapeContext *scShape = SCShape[n][0];
            double min = scQuery->distance(scShape);
            int min_ind = 0;
            for (unsigned int j = 0; j < SCShape[n].size(); j++) {
                ShapeContext *scShape = SCShape[n][j];
                double cost = scQuery->distance(scShape);
                if (cost < min) {
                    min = cost;
                    min_ind = j;
                }
            }
            minValues[i][n] = min;
        }
    }

    for (unsigned int n = 0; n < images.size(); n++) {
            for (int i = 0; i < num; i++) {
                double sum = 0;
                double value = 0;
                for (unsigned int j = 0; j < images.size(); j++) {
                    double minValue = minValues[i][j];
                    if (j == n)
                        value = minValue;
                    sum = sum + minValue;
                }

                N = sum/images.size();

                if (N > 0)
                    d = d + value/N;
            }

            d = d/num;
            distances.push_back(make_tuple(d,images[n]));
    }

    sort(distances.begin(), distances.end(), compareDistanceAndImage);
    return distances;
}
