#include "ShapeContextWindow.h"
#include "OriginalShapeContext.h"
#include "Application.h"

//(*InternalHeaders(ShapeContextWindow)
#include <wx/string.h>
#include <wx/intl.h>
//*)

//(*IdInit(ShapeContextWindow)
const long ShapeContextWindow::ID_LISTBOX1 = wxNewId();
const long ShapeContextWindow::ID_STATICBITMAP4 = wxNewId();
const long ShapeContextWindow::ID_STATICBITMAP3 = wxNewId();
const long ShapeContextWindow::ID_PANEL3 = wxNewId();
//*)

BEGIN_EVENT_TABLE(ShapeContextWindow,wxFrame)
	//(*EventTable(ShapeContextWindow)
	//*)
END_EVENT_TABLE()

ShapeContextWindow::ShapeContextWindow(wxWindow* parent,wxWindowID id,const wxPoint& pos,const wxSize& size)
{
	//(*Initialize(ShapeContextWindow)
	wxBoxSizer* BoxSizer5;

	Create(parent, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("wxID_ANY"));
	SetClientSize(wxSize(433,450));
	ShapeContextPanel = new wxPanel(this, ID_PANEL3, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_PANEL3"));
	BoxSizer3 = new wxBoxSizer(wxHORIZONTAL);
	StaticBoxSizer1 = new wxStaticBoxSizer(wxVERTICAL, ShapeContextPanel, _("Shape Context"));
	BoxSizer5 = new wxBoxSizer(wxHORIZONTAL);
	PointsList = new wxListBox(ShapeContextPanel, ID_LISTBOX1, wxDefaultPosition, wxSize(121,221), 0, 0, 0, wxDefaultValidator, _T("ID_LISTBOX1"));
	BoxSizer5->Add(PointsList, 0, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	BoxSizer4 = new wxBoxSizer(wxVERTICAL);
	bitmapSC_Points = new wxStaticBitmap(ShapeContextPanel, ID_STATICBITMAP4, wxNullBitmap, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICBITMAP4"));
	BoxSizer4->Add(bitmapSC_Points, 1, wxALL|wxEXPAND|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	bitmapSC = new wxStaticBitmap(ShapeContextPanel, ID_STATICBITMAP3, wxNullBitmap, wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICBITMAP3"));
	BoxSizer4->Add(bitmapSC, 1, wxALL|wxEXPAND|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	BoxSizer5->Add(BoxSizer4, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	StaticBoxSizer1->Add(BoxSizer5, 1, wxALL|wxEXPAND|wxFIXED_MINSIZE|wxALIGN_LEFT|wxALIGN_TOP, 5);
	BoxSizer3->Add(StaticBoxSizer1, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	ShapeContextPanel->SetSizer(BoxSizer3);
	BoxSizer3->Fit(ShapeContextPanel);
	BoxSizer3->SetSizeHints(ShapeContextPanel);

	Connect(ID_LISTBOX1,wxEVT_COMMAND_LISTBOX_SELECTED,(wxObjectEventFunction)&ShapeContextWindow::OnPointsListSelect);
	//*)

    Application *app = (Application *) wxTheApp;
    Image* img =  app->getImage();
    if (img != NULL) {
        std::vector<Point> allpts = img->getAllPoints();

        sample(allpts, SAMPLE_SIZE, pts);

        for (unsigned int i = 0; i < pts.size(); i++) {
            PointsList->Append(wxString::Format(wxT("(%d,%d)"),pts[i].x, pts[i].y));
        }
    }

}

ShapeContextWindow::~ShapeContextWindow()
{
	//(*Destroy(ShapeContextWindow)
	//*)
}

//*****************************************************************************/
//* Exibe o shape context do ponto selecionado
//*****************************************************************************/
void ShapeContextWindow::OnPointsListSelect(wxCommandEvent& event) {
    int sel = event.GetInt();
    Application *app = (Application *) wxTheApp;
    Image* img =  app->getImage();

    std::vector<OriginalShapeContext*> SC;
    double m = median(pts);
    for (unsigned int i = 0; i < pts.size(); i++) {
        OriginalShapeContext *sc = new OriginalShapeContext(pts[i]);
        sc->compute(pts, m);
        SC.push_back(sc);
    }

    OriginalShapeContext *sc = SC[sel];
    wxBitmap bmpSC = sc->toBitmap();
    bitmapSC->SetBitmap(bmpSC);


    std::vector<Point> pts;
    for (unsigned int i = 0; i < SC.size(); i++) {
        pts.push_back(SC[i]->getPoint());
    }

    wxBitmap bmpContorno = sc->image(img->getWidth()*2,img->getHeight()*2, pts, m);
    bitmapSC_Points->SetBitmap(bmpContorno);
}
