#ifndef UTILITY_H
#define UTILITY_H

#include "Image.h"
#include <boost/numeric/ublas/matrix.hpp>
#include <boost/tuple/tuple.hpp>
#include "ShapeContext.h"

using namespace boost::numeric::ublas;
using namespace boost;

typedef boost::tuple<double, ShapeContext*,ShapeContext*, int> SCPairLetter;
typedef boost::tuple<double, char, Point> DistanceAndLetter;
typedef boost::tuple<double, Image*> DistanceAndImage;
typedef boost::tuple<double, ShapeContext*,ShapeContext*> CostAndIndices;

bool compareDistanceAndImage (DistanceAndImage a, DistanceAndImage b);
bool compareDistanceAndLetter (DistanceAndLetter a, DistanceAndLetter b);
bool compareCost (CostAndIndices a, CostAndIndices b);
bool comparePair (SCPairLetter a, SCPairLetter b);
bool compareAverage (tuple<double,std::string> a, tuple<double,std::string> b);

matrix<double> computeCost (Image *img1, double median1, Image *img2, double median2);
double median (std::vector<Point> points);
double diffclock(clock_t clock1,clock_t clock2);
Tangent tangent(wxImage img);
void sample(std::vector<Point> allpts, int num, std::vector<Point> &points);

#endif
